#include "graduation_reserch.h"

#ifndef __GC__
#define __GC__

#define HEIGHT 30.0

void sleep(void);

class MyList;
class MyNode;
class D3MyNode;
class MyArc;
class D3MyArc;
class MyGraph;
class Cross_point;
class Time_arc;
class Polygon;
class Pillar;
class Tetrahedral;

class MyList
{
 public:
  MyList(void);
  ~MyList(void);
  MyList* before;
  MyList* next;

  void initialize(void);
  void remove(void);

  MyList* head(void);
  MyList* tail(void);

  MyList* insert(void);
  MyList* insert(MyList*);
  MyList* Insert(void);
  MyList* append(void);
  MyList* push(void);
  MyList* Push(void);
};

class MyNode
{
 public:
  point node;

  MyNode* before;
  MyNode* next;

  bool upper;
  bool center;

  MyNode(void);
  MyNode(point);
  ~MyNode(void);

  void initialize(void);
  void initialize(point);
  void remove();

  MyNode* head(void);
  MyNode* tail(void);

  MyNode* insert(void);
  MyNode* insert(point);
  MyNode* insert(MyNode*);
  MyNode* Insert(void);
  MyNode* Insert(point);
  MyNode* Insert(MyNode*);
  MyNode* append(void);
  MyNode* append(point);
  MyNode* append(MyNode*);
  MyNode* push(void);
  MyNode* push(point);
  MyNode* push(MyNode*);
  MyNode* Push(void);
  MyNode* Push(point);
  MyNode* Push(MyNode*);
  MyNode* search(point);
  MyNode* Search(point);

  void input(point);

  point value(void);
  point Before(void);
  point Next(void);
  point first(void);
  point last(void);
};

class D3MyNode
{
 public:
  d3_point node;

  MyNode* master;

  D3MyNode* before;
  D3MyNode* next;

  bool in_knot;

  D3MyNode(void);
  D3MyNode(d3_point);
  D3MyNode(MyNode*);
  D3MyNode(MyNode*, double);
  ~D3MyNode(void);

  void initialize(void);
  void initialize(d3_point);
  void initialize(MyNode*);
  void initialize(MyNode*, double);
  void remove(void);

  D3MyNode* head(void);
  D3MyNode* tail(void);

  D3MyNode* insert(void);
  D3MyNode* insert(d3_point);
  D3MyNode* insert(MyNode*);
  D3MyNode* insert(MyNode*, double);
  D3MyNode* insert(D3MyNode*);
  D3MyNode* Insert(void);
  D3MyNode* Insert(d3_point);
  D3MyNode* Insert(MyNode*);
  D3MyNode* Insert(D3MyNode*);
  D3MyNode* append(void);
  D3MyNode* append(d3_point);
  D3MyNode* append(MyNode*);
  D3MyNode* append(MyNode*, double);
  D3MyNode* append(D3MyNode*);
  D3MyNode* push(void);
  D3MyNode* push(d3_point);
  D3MyNode* push(MyNode*);
  D3MyNode* push(MyNode*, double);
  D3MyNode* push(D3MyNode*);
  D3MyNode* Push(void);
  D3MyNode* Push(d3_point);
  D3MyNode* Push(MyNode*);
  D3MyNode* Push(D3MyNode*);
  D3MyNode* search(d3_point);
  D3MyNode* Search(d3_point);

  D3MyNode* convert(MyNode*, double);

  void input(d3_point);
};

class MyArc
{
 public:
  segment arc;

  MyNode* from;
  MyNode* to;

  MyArc* before;
  MyArc* next;

  bool in_knot;

  MyArc(void);
  MyArc(MyNode*, MyNode*);
  ~MyArc(void);

  void initialize(void);
  void initialize(MyNode*, MyNode*);
  void remove(void);

  MyArc* head(void);
  MyArc* tail(void);

  MyArc* insert(void);
  MyArc* insert(MyNode*, MyNode*);
  MyArc* insert(MyArc*);
  MyArc* Insert(void);
  MyArc* Insert(MyNode*, MyNode*);
  MyArc* Insert(MyArc*);
  MyArc* append(void);
  MyArc* append(MyNode*, MyNode*);
  MyArc* append(MyArc*);
  MyArc* push(void);
  MyArc* push(MyNode*, MyNode*);
  MyArc* push(MyArc*);  // Not yet
  MyArc* Push(void);
  MyArc* Push(MyNode*, MyNode*);

  MyArc* search(MyNode*);
  MyArc* search(segment);
  MyArc* search(MyNode*, MyNode*);
  MyArc* Search(MyNode*);
  MyArc* Search(segment);
  MyArc* Search(MyNode*, MyNode*);

  bool is_cross(point);
  bool is_cross(MyNode*);
  bool is_cross(segment);
  bool is_cross(MyNode*, MyNode*);
  bool is_cross(MyArc*);

  void input(MyNode*, MyNode*);

  segment value(void);
  segment Before(void);
  segment Next(void);
  segment first(void);
  segment last(void);
  MyNode* From(void);
  MyNode* To(void);
};

class D3MyArc
{
 public:
  d3_segment arc;

  D3MyNode* from;
  D3MyNode* to;

  D3MyArc* before;
  D3MyArc* next;

  bool in_knot;

  D3MyArc(void);
  D3MyArc(D3MyNode*, D3MyNode*);
  ~D3MyArc(void);

  void initialize(void);
  void initialize(D3MyNode*, D3MyNode*);
  void remove(void);

  void input(D3MyNode*, D3MyNode*);

  D3MyArc* head(void);
  D3MyArc* tail(void);

  D3MyArc* insert(void);
  D3MyArc* insert(D3MyNode*, D3MyNode*);
  D3MyArc* insert(D3MyArc*);
  D3MyArc* Insert(void);
  D3MyArc* Insert(D3MyNode*, D3MyNode*);
  D3MyArc* Insert(D3MyArc*);
  D3MyArc* append(void);
  D3MyArc* append(D3MyNode*, D3MyNode*);
  D3MyArc* append(D3MyArc*);
  D3MyArc* push(void);
  D3MyArc* push(D3MyNode*, D3MyNode*);
  D3MyArc* push(D3MyArc*);  // Not yet
  D3MyArc* Push(void);
  D3MyArc* Push(D3MyNode*, D3MyNode*);

  D3MyArc* convert(MyNode*, MyArc*, double);
};

class Cross_point
{
 public:
  point x;
  char flag;
  MyArc* a;
  MyArc* b;

  Cross_point* before;
  Cross_point* next;

  Cross_point(void);
  Cross_point(MyArc*, MyArc*);
  Cross_point(char, MyArc*, MyArc*);
  ~Cross_point(void);

  void initialize(void);
  void initialize(MyArc*, MyArc*);
  void initialize(char, MyArc*, MyArc*);
  void remove(void);

  Cross_point* head(void);
  Cross_point* tail(void);

  Cross_point* insert(void);
  Cross_point* insert(MyArc*, MyArc*);
  Cross_point* insert(char, MyArc*, MyArc*);
  Cross_point* Insert(void);
  Cross_point* Insert(MyArc*, MyArc*);
  Cross_point* Insert(char, MyArc*, MyArc*);
  Cross_point* append(void);
  Cross_point* append(MyArc*, MyArc*);
  Cross_point* append(char, MyArc*, MyArc*);
  Cross_point* push(void);
  Cross_point* push(MyArc*, MyArc*);
  Cross_point* push(char, MyArc*, MyArc*);
  Cross_point* Push(void);
  Cross_point* Push(MyArc*, MyArc*);
  Cross_point* Push(char, MyArc*, MyArc*);

  void input(char);
  void input(MyArc*, MyArc*);
  void input(char, MyArc*, MyArc*);

  point value(void);
  point Before(void);
  point Next(void);
  point first(void);
  point last(void);
  char Flag(void);

  bool is_upper(point, point);
  bool is_downner(point, point);

};

class Time_arc{
public:
  MyArc* M;
  segment s;
  MyNode* X;
  MyNode* N;

  Time_arc(void);
  Time_arc(MyArc*);
  ~Time_arc(void);

  void initialize(void);
  void initialize(MyArc*);
  void remove(void);

  void clean(void);
  void clean(MyArc*);

  MyNode* remove_from_X(MyNode*);

  void sort(void);

  void insert(point);
  void insert(MyArc*, MyArc*);

  MyNode* get_ancor(void);
};

class MyGraph{
 public:
  MyNode* nodes;
  MyArc* arcs;

  MyNode* space_nodes;
  MyArc* space_arcs;

  MyGraph(void);
  MyGraph(list<point>*);
  MyGraph(list<point>);
  MyGraph(MyNode*);
  MyGraph(MyArc*);
  ~MyGraph(void);

  void initialize(void);
  void initialize(list<point>*);
  void initialize(list<point>);
  void initialize(MyNode*);
  void initialize(MyNode);
  void initialize(MyArc*);
  void remove(void);

  void insert_to_knot(point);

  void add_node(MyNode*, point);
  void add_node(MyNode*, list<point>*);
  void add_node(MyNode*, list<point>);
  void add_node(MyNode*, MyNode*);

  void remove_node();

  void add_space(point);
  void add_space(list<point>*);
  void add_space(list<point>);
  void add_space(MyNode*);

  bool is_include(point);
  bool is_include(MyNode*);
  bool is_include(MyNode);
  bool is_include(segment);
  bool is_include(MyArc*);
  bool is_include(MyArc);

  bool is_in(point);
  bool is_in(MyNode*);
  bool is_in(MyNode);
  bool is_in(segment);
  bool is_in(MyArc*);
  bool is_in(MyArc);

  bool is_cross(MyNode*, MyNode*);
  bool is_cross(MyNode, MyNode);
  bool is_cross(segment);
  bool is_cross(MyArc*);
  bool is_cross(MyArc);

  void get_arcs(void);
  void get_space(void);
  void get_space(window*);

  MyNode* get_node(point);
  MyNode* get_node(MyNode*);
  MyNode* get_space_node(point);
  MyNode* get_space_node(MyNode*);

  MyArc* get_arc(MyNode*);
  MyArc* get_arc(segment);
  MyArc* get_space_arc(MyNode*);
  MyArc* get_space_arc(MyArc*);

  bool is_connect(MyArc*, MyArc*);
  bool is_triangule(MyArc*, MyArc*, MyArc*);
  bool is_there_inner_point(MyNode*, MyNode*, MyNode*);
  MyNode* get_polygons(void);
};

class Polygon{
 public:
  D3MyNode* a;
  D3MyNode* b;
  D3MyNode* c;

  D3MyArc* bc;
  D3MyArc* ca;
  D3MyArc* ab;

  Polygon* before;
  Polygon* next;

  bool a_is_knot; 
  bool b_is_knot;
  bool c_is_knot;

  Polygon(D3MyNode*, D3MyNode*, D3MyNode*);
  ~Polygon(void);

  void initialize(void);
  void initialize(D3MyNode*, D3MyNode*, D3MyNode*);
  void remove(void);

  Polygon* head(void);
  Polygon* tail(void);

  Polygon* insert(D3MyNode*, D3MyNode*, D3MyNode*);
  Polygon* insert(Polygon*);
  Polygon* append(D3MyNode*, D3MyNode*, D3MyNode*);
  Polygon* append(Polygon*);
  Polygon* push(D3MyNode*, D3MyNode*, D3MyNode*);
  Polygon* push(Polygon*);

  void input(D3MyNode*, D3MyNode*, D3MyNode*);

  D3MyNode* search(d3_point);
  D3MyNode* search_before(d3_point);
  D3MyNode* search_next(d3_point);

  D3MyNode* search(D3MyNode*);
  D3MyNode* search_before(D3MyNode*);
  D3MyNode* search_next(D3MyNode*);

  D3MyArc* search(D3MyArc*);
  D3MyArc* search_before(D3MyArc*);
  D3MyArc* search_next(D3MyArc*);

  Polygon* subdivision(void);
  void convert(void);
};

class Pillar{
 public:
  Polygon* ceiling;
  Polygon* floor;

  Polygon* bc_wall;
  Polygon* ca_wall;
  Polygon* ab_wall;

  Pillar* before;
  Pillar* next;

  point m_a;
  point m_b;
  point m_c;

  Pillar(void);
  Pillar(MyNode*, MyNode*, MyNode*);
  ~Pillar(void);

  void initialize(void);
  void initialize(MyNode*, MyNode*, MyNode*);
  void remove(void);

  Pillar* head(void);
  Pillar* tail(void);

  Pillar* insert(MyNode*, MyNode*, MyNode*);
  Pillar* insert(Pillar*);
  Pillar* append(MyNode*, MyNode*, MyNode*);
  Pillar* append(Pillar*);
  Pillar* push(MyNode*, MyNode*, MyNode*);
  Pillar* push(Pillar*);

  D3MyNode* search(D3MyNode*);
  D3MyNode* search_before(D3MyNode*);
  D3MyNode* search_next(D3MyNode*);

  D3MyArc* search(D3MyArc*);
  D3MyArc* search_before(D3MyArc*);
  D3MyArc* search_next(D3MyArc*);

  void convert(void);      // ¾Pillar򸫤ƱĺͭФ礹롣(ǽ˸դäĺ˥ݥ󥿤礻)

  void switching(MyNode*); // knotäƥե饰ڤ괹

  Tetrahedral* get_parts(void);
};

class Tetrahedral{
 public:
  Polygon* a;
  Polygon* b;
  Polygon* c;
  Polygon* d;

  Tetrahedral* before;
  Tetrahedral* next;

  Tetrahedral(Polygon*, Polygon*, Polygon*, Polygon*);
  ~Tetrahedral(void);

  void initialize(void);
  void initialize(Polygon*, Polygon*, Polygon*, Polygon*);
  void remove(void);

  Tetrahedral* head(void);
  Tetrahedral* tail(void);

  Tetrahedral* insert(Polygon*, Polygon*, Polygon*, Polygon*);
  Tetrahedral* insert(Tetrahedral*);

  Tetrahedral* append(Polygon*, Polygon*, Polygon*, Polygon*);
  Tetrahedral* append(Tetrahedral*);
  Tetrahedral* push(Polygon*, Polygon*, Polygon*, Polygon*);
  Tetrahedral* push(Tetrahedral*);

  Tetrahedral* subdivision(void);

  D3MyNode* get_gravity_point(void);
};

class D3Graph{
 public:
  MyNode* knot;
  MyGraph* master;

  D3MyNode* area;
  Pillar*   cake;
  Tetrahedral* space;
  //  Tetrahedral* knot_image;

  int subdivision_time;

  GRAPH<d3_point, int>* NEIGHBOR;
  GRAPH<d3_point, int>* ALL;
  GRAPH<d3_point, int>* C_HULL;

  D3Graph(void);
  D3Graph(MyNode*);
  D3Graph(MyGraph*);
  D3Graph(MyNode*, MyGraph*);
  D3Graph(MyGraph*, MyNode*);
  ~D3Graph(void);

  void initialize(void);
  void initialize(MyNode*);
  void initialize(MyGraph*);
  void initialize(MyNode*, MyGraph*);
  void initialize(MyGraph*, MyNode*);
  void remove(void);

  Pillar*      get_pillars(void);
  Tetrahedral* get_tetrahedral(void);
  Tetrahedral* subdivision(void);

  GRAPH<d3_point, int>* construct_space(void);
  GRAPH<d3_point, int>* construct_neighborhood(void);

  bool is_the_node_in_the_knot_from_all(node);
  bool is_the_node_in_the_knot_from_all(d3_point);
  bool is_the_edge_in_the_knot_from_all(edge);
};

#endif
